SystemOrganization addCategory: #'OB-Dev-FTP'!

FTPContext subclass: #FTPInternalFile
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Dev-FTP'!

!FTPInternalFile class methodsFor: 'as yet unclassified' stamp: 'cwp 8/2/2007 23:16'!
file: anInternalFile
	^ self new setFile: anInternalFile! !

!FTPInternalFile methodsFor: 'accessing' stamp: 'cwp 8/2/2007 23:18'!
contents
	^ file contents! !

!FTPInternalFile methodsFor: 'accessing' stamp: 'cwp 8/2/2007 23:20'!
contents: aString
	| source |
	source _ String streamContents:
		[:stream |
		stream 
			nextPutAll: 'contents';
			cr; tab;
			nextPutAll: '^ ';
			print: aString].
	file class compile: source! !

!FTPInternalFile methodsFor: 'accessing' stamp: 'cwp 8/3/2007 00:16'!
groupName
	^ self ownerName! !

!FTPInternalFile methodsFor: 'accessing' stamp: 'cwp 8/3/2007 00:20'!
modification
	| stream |
	stream := ReadStream on: self timeStamp.
	stream skipSeparators.
	stream skipTo: Character space.
	^ TimeStamp readFrom: stream! !

!FTPInternalFile methodsFor: 'accessing' stamp: 'cwp 8/2/2007 23:23'!
name
	^ file name! !

!FTPInternalFile methodsFor: 'accessing' stamp: 'cwp 8/3/2007 00:15'!
ownerName
	^ self timeStamp withBlanksTrimmed upTo: Character space! !

!FTPInternalFile methodsFor: 'initialize' stamp: 'cwp 8/2/2007 23:16'!
setFile: anInternalFile
	file _ anInternalFile! !

!FTPInternalFile methodsFor: 'accessing' stamp: 'cwp 8/3/2007 00:11'!
size
	^ self contents size! !

!FTPInternalFile methodsFor: 'private' stamp: 'cwp 8/3/2007 00:14'!
timeStamp
	^(file class compiledMethodAt: #contents) timeStamp! !

!FTPServer class methodsFor: '*ob-dev-ftp' stamp: 'cwp 8/12/2007 12:59'!
startForOBDev
	| dispatcher |
	FTPServer stopAll.
	dispatcher _ FTPDispatcher new.
	OBInternalFile allFiles do: [:ea | dispatcher add: (FTPInternalFile file: ea)].
	^ FTPServer startOn: 10021 context: dispatcher.
! !
